// $ANTLR 2.7.1: "ldapv3schema.g" -> "LDAPv3SchemaParser.java"$
 
    import java.util.Vector;
    import java.util.HashMap;

import antlr.TokenBuffer;
import antlr.TokenStreamException;
import antlr.TokenStreamIOException;
import antlr.ANTLRException;
import antlr.LLkParser;
import antlr.Token;
import antlr.TokenStream;
import antlr.RecognitionException;
import antlr.NoViableAltException;
import antlr.MismatchedTokenException;
import antlr.SemanticException;
import antlr.ParserSharedInputState;
import antlr.collections.impl.BitSet;
import antlr.collections.AST;
import antlr.ASTPair;
import antlr.collections.impl.ASTArray;

/** 
 * This a grammar for LDAPv3 schema definitions
 * inspired from 
 *  "Understanding And Deploying LDAP Directory Services"
 *   Timothy A Howes, Ph.D. Mark C. Smith, Gordon S. Good
 *   Macmillan Technical Publishing, USA, 1999
 *   respectively rfc 2252
*/
public class LDAPv3SchemaParser extends antlr.LLkParser
       implements LDAPv3SchemaParserTokenTypes
 {

protected LDAPv3SchemaParser(TokenBuffer tokenBuf, int k) {
  super(tokenBuf,k);
  tokenNames = _tokenNames;
}

public LDAPv3SchemaParser(TokenBuffer tokenBuf) {
  this(tokenBuf,20);
}

protected LDAPv3SchemaParser(TokenStream lexer, int k) {
  super(lexer,k);
  tokenNames = _tokenNames;
}

public LDAPv3SchemaParser(TokenStream lexer) {
  this(lexer,20);
}

public LDAPv3SchemaParser(ParserSharedInputState state) {
  super(state,20);
  tokenNames = _tokenNames;
}

	public final java.util.Vector  schema() throws RecognitionException, TokenStreamException {
		java.util.Vector vec;
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST schema_AST = null;
		
		vec = new java.util.Vector();
		AttributeType at;
		ObjectClass   oc;
		
		
		
		try {      // for error handling
			{
			int _cnt3=0;
			_loop3:
			do {
				switch ( LA(1)) {
				case LITERAL_attributetype:
				{
					at=attributetype();
					astFactory.addASTChild(currentAST, returnAST);
					
					vec.add(at);
					
					break;
				}
				case LITERAL_objectclass:
				case LITERAL_objectClass:
				{
					oc=objectclass();
					astFactory.addASTChild(currentAST, returnAST);
					
					vec.add(oc);
					
					break;
				}
				default:
				{
					if ( _cnt3>=1 ) { break _loop3; } else {throw new NoViableAltException(LT(1), getFilename());}
				}
				}
				_cnt3++;
			} while (true);
			}
			schema_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_0);
		}
		returnAST = schema_AST;
		return vec;
	}
	
	public final AttributeType  attributetype() throws RecognitionException, TokenStreamException {
		AttributeType at;
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST attributetype_AST = null;
		Token  oid = null;
		AST oid_AST = null;
		Token  name = null;
		AST name_AST = null;
		Token  obsolete = null;
		AST obsolete_AST = null;
		Token  desc = null;
		AST desc_AST = null;
		
		at=new AttributeType(); 
		String supOid=null;
		String eqOid=null;
		String orderingOid=null;
		String substrOid=null;
		
		
		try {      // for error handling
			AST tmp1_AST = null;
			tmp1_AST = (AST)astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp1_AST);
			match(LITERAL_attributetype);
			AST tmp2_AST = null;
			tmp2_AST = (AST)astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp2_AST);
			match(LPAREN);
			{
			switch ( LA(1)) {
			case NUMERICOID:
			{
				oid = LT(1);
				oid_AST = (AST)astFactory.create(oid);
				astFactory.addASTChild(currentAST, oid_AST);
				match(NUMERICOID);
				break;
			}
			case LITERAL_NAME:
			case LITERAL_OBSOLETE:
			case DESCR:
			case LITERAL_SUP:
			case LITERAL_EQUALITY:
			case LITERAL_ORDERING:
			case LITERAL_SUBSTR:
			case LITERAL_SYNTAX:
			case 16:
			case LITERAL_COLLECTIVE:
			case 18:
			case LITERAL_USAGE:
			case RPAREN:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			{
			switch ( LA(1)) {
			case LITERAL_NAME:
			{
				AST tmp3_AST = null;
				tmp3_AST = (AST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp3_AST);
				match(LITERAL_NAME);
				name = LT(1);
				name_AST = (AST)astFactory.create(name);
				astFactory.addASTChild(currentAST, name_AST);
				match(QIDENT);
				break;
			}
			case LITERAL_OBSOLETE:
			case DESCR:
			case LITERAL_SUP:
			case LITERAL_EQUALITY:
			case LITERAL_ORDERING:
			case LITERAL_SUBSTR:
			case LITERAL_SYNTAX:
			case 16:
			case LITERAL_COLLECTIVE:
			case 18:
			case LITERAL_USAGE:
			case RPAREN:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			{
			switch ( LA(1)) {
			case LITERAL_OBSOLETE:
			{
				obsolete = LT(1);
				obsolete_AST = (AST)astFactory.create(obsolete);
				astFactory.addASTChild(currentAST, obsolete_AST);
				match(LITERAL_OBSOLETE);
				break;
			}
			case DESCR:
			case LITERAL_SUP:
			case LITERAL_EQUALITY:
			case LITERAL_ORDERING:
			case LITERAL_SUBSTR:
			case LITERAL_SYNTAX:
			case 16:
			case LITERAL_COLLECTIVE:
			case 18:
			case LITERAL_USAGE:
			case RPAREN:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			{
			switch ( LA(1)) {
			case DESCR:
			{
				desc = LT(1);
				desc_AST = (AST)astFactory.create(desc);
				astFactory.addASTChild(currentAST, desc_AST);
				match(DESCR);
				break;
			}
			case LITERAL_SUP:
			case LITERAL_EQUALITY:
			case LITERAL_ORDERING:
			case LITERAL_SUBSTR:
			case LITERAL_SYNTAX:
			case 16:
			case LITERAL_COLLECTIVE:
			case 18:
			case LITERAL_USAGE:
			case RPAREN:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			{
			switch ( LA(1)) {
			case LITERAL_SUP:
			{
				AST tmp4_AST = null;
				tmp4_AST = (AST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp4_AST);
				match(LITERAL_SUP);
				supOid=oid();
				astFactory.addASTChild(currentAST, returnAST);
				break;
			}
			case LITERAL_EQUALITY:
			case LITERAL_ORDERING:
			case LITERAL_SUBSTR:
			case LITERAL_SYNTAX:
			case 16:
			case LITERAL_COLLECTIVE:
			case 18:
			case LITERAL_USAGE:
			case RPAREN:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			{
			switch ( LA(1)) {
			case LITERAL_EQUALITY:
			{
				AST tmp5_AST = null;
				tmp5_AST = (AST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp5_AST);
				match(LITERAL_EQUALITY);
				eqOid=oid();
				astFactory.addASTChild(currentAST, returnAST);
				break;
			}
			case LITERAL_ORDERING:
			case LITERAL_SUBSTR:
			case LITERAL_SYNTAX:
			case 16:
			case LITERAL_COLLECTIVE:
			case 18:
			case LITERAL_USAGE:
			case RPAREN:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			{
			switch ( LA(1)) {
			case LITERAL_ORDERING:
			{
				AST tmp6_AST = null;
				tmp6_AST = (AST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp6_AST);
				match(LITERAL_ORDERING);
				orderingOid=oid();
				astFactory.addASTChild(currentAST, returnAST);
				break;
			}
			case LITERAL_SUBSTR:
			case LITERAL_SYNTAX:
			case 16:
			case LITERAL_COLLECTIVE:
			case 18:
			case LITERAL_USAGE:
			case RPAREN:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			{
			switch ( LA(1)) {
			case LITERAL_SUBSTR:
			{
				AST tmp7_AST = null;
				tmp7_AST = (AST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp7_AST);
				match(LITERAL_SUBSTR);
				substrOid=oid();
				astFactory.addASTChild(currentAST, returnAST);
				break;
			}
			case LITERAL_SYNTAX:
			case 16:
			case LITERAL_COLLECTIVE:
			case 18:
			case LITERAL_USAGE:
			case RPAREN:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			{
			switch ( LA(1)) {
			case LITERAL_SYNTAX:
			{
				AST tmp8_AST = null;
				tmp8_AST = (AST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp8_AST);
				match(LITERAL_SYNTAX);
				break;
			}
			case 16:
			case LITERAL_COLLECTIVE:
			case 18:
			case LITERAL_USAGE:
			case RPAREN:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			{
			switch ( LA(1)) {
			case 16:
			{
				AST tmp9_AST = null;
				tmp9_AST = (AST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp9_AST);
				match(16);
				break;
			}
			case LITERAL_COLLECTIVE:
			case 18:
			case LITERAL_USAGE:
			case RPAREN:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			{
			switch ( LA(1)) {
			case LITERAL_COLLECTIVE:
			{
				AST tmp10_AST = null;
				tmp10_AST = (AST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp10_AST);
				match(LITERAL_COLLECTIVE);
				break;
			}
			case 18:
			case LITERAL_USAGE:
			case RPAREN:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			{
			switch ( LA(1)) {
			case 18:
			{
				AST tmp11_AST = null;
				tmp11_AST = (AST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp11_AST);
				match(18);
				break;
			}
			case LITERAL_USAGE:
			case RPAREN:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			{
			switch ( LA(1)) {
			case LITERAL_USAGE:
			{
				AST tmp12_AST = null;
				tmp12_AST = (AST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp12_AST);
				match(LITERAL_USAGE);
				break;
			}
			case RPAREN:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			AST tmp13_AST = null;
			tmp13_AST = (AST)astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp13_AST);
			match(RPAREN);
			
				     at.setOid(oid.getText());
			if (name != null) at.setName( name.getText());
			if (desc != null) at.setDescription( desc.getText());
			if (obsolete != null) at.setObsolete( true );
			//System.out.println("\n" + at.toLdapV3Format() + "\n");
			
			attributetype_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_1);
		}
		returnAST = attributetype_AST;
		return at;
	}
	
	public final ObjectClass  objectclass() throws RecognitionException, TokenStreamException {
		ObjectClass oc;
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST objectclass_AST = null;
		Token  oid = null;
		AST oid_AST = null;
		Token  name = null;
		AST name_AST = null;
		Token  desc = null;
		AST desc_AST = null;
		Token  obsolete = null;
		AST obsolete_AST = null;
		
			oc = new ObjectClass();
			Vector supOids = null;
			Vector mustOids = null;
			Vector mayOids = null;
		
		
		try {      // for error handling
			{
			switch ( LA(1)) {
			case LITERAL_objectclass:
			{
				AST tmp14_AST = null;
				tmp14_AST = (AST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp14_AST);
				match(LITERAL_objectclass);
				break;
			}
			case LITERAL_objectClass:
			{
				AST tmp15_AST = null;
				tmp15_AST = (AST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp15_AST);
				match(LITERAL_objectClass);
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			AST tmp16_AST = null;
			tmp16_AST = (AST)astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp16_AST);
			match(LPAREN);
			oid = LT(1);
			oid_AST = (AST)astFactory.create(oid);
			astFactory.addASTChild(currentAST, oid_AST);
			match(NUMERICOID);
			{
			switch ( LA(1)) {
			case LITERAL_NAME:
			{
				AST tmp17_AST = null;
				tmp17_AST = (AST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp17_AST);
				match(LITERAL_NAME);
				name = LT(1);
				name_AST = (AST)astFactory.create(name);
				astFactory.addASTChild(currentAST, name_AST);
				match(QIDENT);
				break;
			}
			case LITERAL_OBSOLETE:
			case DESCR:
			case LITERAL_SUP:
			case RPAREN:
			case LITERAL_MUST:
			case LITERAL_MAY:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			{
			switch ( LA(1)) {
			case DESCR:
			{
				desc = LT(1);
				desc_AST = (AST)astFactory.create(desc);
				astFactory.addASTChild(currentAST, desc_AST);
				match(DESCR);
				break;
			}
			case LITERAL_OBSOLETE:
			case LITERAL_SUP:
			case RPAREN:
			case LITERAL_MUST:
			case LITERAL_MAY:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			{
			switch ( LA(1)) {
			case LITERAL_OBSOLETE:
			{
				obsolete = LT(1);
				obsolete_AST = (AST)astFactory.create(obsolete);
				astFactory.addASTChild(currentAST, obsolete_AST);
				match(LITERAL_OBSOLETE);
				break;
			}
			case LITERAL_SUP:
			case RPAREN:
			case LITERAL_MUST:
			case LITERAL_MAY:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			{
			switch ( LA(1)) {
			case LITERAL_SUP:
			{
				AST tmp18_AST = null;
				tmp18_AST = (AST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp18_AST);
				match(LITERAL_SUP);
				supOids=oids();
				astFactory.addASTChild(currentAST, returnAST);
				break;
			}
			case RPAREN:
			case LITERAL_MUST:
			case LITERAL_MAY:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			{
			switch ( LA(1)) {
			case LITERAL_MUST:
			{
				AST tmp19_AST = null;
				tmp19_AST = (AST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp19_AST);
				match(LITERAL_MUST);
				mustOids=oids();
				astFactory.addASTChild(currentAST, returnAST);
				break;
			}
			case RPAREN:
			case LITERAL_MAY:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			{
			switch ( LA(1)) {
			case LITERAL_MAY:
			{
				AST tmp20_AST = null;
				tmp20_AST = (AST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp20_AST);
				match(LITERAL_MAY);
				mayOids=oids();
				astFactory.addASTChild(currentAST, returnAST);
				break;
			}
			case RPAREN:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			AST tmp21_AST = null;
			tmp21_AST = (AST)astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp21_AST);
			match(RPAREN);
			
				  oc.setOid(oid.getText());
				  if (name != null) oc.setName(name.getText());
				  oc.setSuperclasses (supOids);
				  oc.setRequiredAttributes (mustOids);
				  oc.setOptionalAttributes (mayOids);
			
			objectclass_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_1);
		}
		returnAST = objectclass_AST;
		return oc;
	}
	
	public final String  oid() throws RecognitionException, TokenStreamException {
		String oid;
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST oid_AST = null;
		Token  tokn = null;
		AST tokn_AST = null;
		Token  toki = null;
		AST toki_AST = null;
		
		oid = null;
		
		
		try {      // for error handling
			switch ( LA(1)) {
			case NUMERICOID:
			{
				tokn = LT(1);
				tokn_AST = (AST)astFactory.create(tokn);
				astFactory.addASTChild(currentAST, tokn_AST);
				match(NUMERICOID);
				
					  oid = tokn.getText();
				
				oid_AST = (AST)currentAST.root;
				break;
			}
			case IDENT:
			{
				toki = LT(1);
				toki_AST = (AST)astFactory.create(toki);
				astFactory.addASTChild(currentAST, toki_AST);
				match(IDENT);
				
					  oid = toki.getText();
				
				oid_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_2);
		}
		returnAST = oid_AST;
		return oid;
	}
	
	public final Vector  oids() throws RecognitionException, TokenStreamException {
		Vector oids;
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST oids_AST = null;
		
		oids = new Vector();
		String oid = null;
		
		
		try {      // for error handling
			switch ( LA(1)) {
			case NUMERICOID:
			case IDENT:
			{
				{
				oid=oid();
				astFactory.addASTChild(currentAST, returnAST);
				oids.add(oid);
				}
				oids_AST = (AST)currentAST.root;
				break;
			}
			case LPAREN:
			{
				AST tmp22_AST = null;
				tmp22_AST = (AST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp22_AST);
				match(LPAREN);
				oid=oid();
				astFactory.addASTChild(currentAST, returnAST);
				oids.add(oid);
				{
				int _cnt29=0;
				_loop29:
				do {
					if ((LA(1)==DOLLAR)) {
						AST tmp23_AST = null;
						tmp23_AST = (AST)astFactory.create(LT(1));
						astFactory.addASTChild(currentAST, tmp23_AST);
						match(DOLLAR);
						oid=oid();
						astFactory.addASTChild(currentAST, returnAST);
						oids.add(oid);
					}
					else {
						if ( _cnt29>=1 ) { break _loop29; } else {throw new NoViableAltException(LT(1), getFilename());}
					}
					
					_cnt29++;
				} while (true);
				}
				AST tmp24_AST = null;
				tmp24_AST = (AST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp24_AST);
				match(RPAREN);
				oids_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_3);
		}
		returnAST = oids_AST;
		return oids;
	}
	
	
	public static final String[] _tokenNames = {
		"<0>",
		"EOF",
		"<2>",
		"NULL_TREE_LOOKAHEAD",
		"\"attributetype\"",
		"LPAREN",
		"NUMERICOID",
		"\"NAME\"",
		"a quoted identifier",
		"\"OBSOLETE\"",
		"DESCR",
		"\"SUP\"",
		"\"EQUALITY\"",
		"\"ORDERING\"",
		"\"SUBSTR\"",
		"\"SYNTAX\"",
		"\"SINGLE-VALUE\"",
		"\"COLLECTIVE\"",
		"\"NO-USER-MODIFICATION\"",
		"\"USAGE\"",
		"RPAREN",
		"\"objectclass\"",
		"\"objectClass\"",
		"\"MUST\"",
		"\"MAY\"",
		"DOLLAR",
		"an identifer",
		"white space",
		"COMMENT",
		"DOT",
		"a single quoted string",
		"a digit",
		"INT"
	};
	
	private static final long _tokenSet_0_data_[] = { 2L, 0L };
	public static final BitSet _tokenSet_0 = new BitSet(_tokenSet_0_data_);
	private static final long _tokenSet_1_data_[] = { 6291474L, 0L };
	public static final BitSet _tokenSet_1 = new BitSet(_tokenSet_1_data_);
	private static final long _tokenSet_2_data_[] = { 60813312L, 0L };
	public static final BitSet _tokenSet_2 = new BitSet(_tokenSet_2_data_);
	private static final long _tokenSet_3_data_[] = { 26214400L, 0L };
	public static final BitSet _tokenSet_3 = new BitSet(_tokenSet_3_data_);
	
	}
